"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformVoidExpressionStatement = exports.transformVoidExpression = void 0;
const ts = require("typescript");
const lua = require("../../LuaAST");
// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/void
const transformVoidExpression = (node, context) => {
    // If content is a literal it is safe to replace the entire expression with nil
    if (!ts.isLiteralExpression(node.expression)) {
        // local ____ = <expression>
        context.addPrecedingStatements(lua.createVariableDeclarationStatement(lua.createAnonymousIdentifier(), context.transformExpression(node.expression)));
    }
    return lua.createNilLiteral(node);
};
exports.transformVoidExpression = transformVoidExpression;
const transformVoidExpressionStatement = (node, context) => 
// In case of a void expression statement we can omit the IIFE
lua.createVariableDeclarationStatement(lua.createAnonymousIdentifier(), context.transformExpression(node.expression), node);
exports.transformVoidExpressionStatement = transformVoidExpressionStatement;
//# sourceMappingURL=void.js.map